Imports System.Data.SqlClient

Public Class CategoryDB

    Public Shared Function findCategory(ByVal strCategoryID As String) As clsCategory
        Try
            'Step 1: Build a Connection object
            Dim connection As SqlConnection = ConnectionDB.getConnection()

            'Step 2: Build your SQL statement
            Dim strSelectStatement As String = "SELECT CategoryID, ShortName, LongName FROM [Halloween].[dbo].[Categories]" & _
                " WHERE CategoryID='" & strCategoryID & "'"

            'Step 3: Build a Command object with your SQL statement for your connection
            Dim command As New SqlCommand(strSelectStatement, connection)

            'Step 4: Open your Connection
            connection.Open()

            'Step 5: Execute your SQL command. In this case, we execute a SELECT statement and the results will go to a DataReader object
            Dim reader As SqlDataReader = command.ExecuteReader()

            Dim hc As clsCategory = Nothing

            If reader.Read Then
                hc = New clsCategory(reader.GetString(0), reader.GetString(1), reader.GetString(2))
            Else
                Throw New DataException("ERROR HC 001: Category ID=" & strCategoryID & " was not found in the database.")
            End If

            connection.Close()
            Return hc
        Catch ex As Exception
            Throw (ex)
        End Try

    End Function

    Public Shared Function createCategory(ByRef myCategory As clsCategory) As Integer
        Dim intCreateCategoryResult As Integer = 0
        Try
            Dim connection As SqlConnection = ConnectionDB.getConnection()
            Dim strInsertStatement As String = "INSERT INTO Categories (CategoryID, ShortName, LongName) VALUES ('" & _
                                                myCategory.CategoryID & "', '" & _
                                                myCategory.ShortName & "', '" & _
                                                myCategory.LongName & "')"
            Dim command As New SqlCommand(strInsertStatement, connection)
            connection.Open()
            intCreateCategoryResult = command.ExecuteNonQuery
            connection.Close()
            Return intCreateCategoryResult
        Catch ex As Exception
            Throw New DataException("ERROR HC 002: Category ID=" & myCategory.CategoryID & " was not added in the database.")
        End Try
    End Function

End Class
